
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[原创]W2k Driving 学习笔记(一)内核线程及同步 / iVAN</title>

    <meta name="description" content="[原创]W2k Driving 学习笔记(一)内核线程及同步 [大体流程] Win32与Kernel交互,从User层向内核发送2个请求: 0 IOCTL_Start_Thread : 从内核新建一个线程,最多建立MAX_THREAD_NUM个线程: 1 IOCTL_Stop_Thread : 关闭刚才建立的所有线程: 每个线程做同样的事,每次将变量Count增加1,使用一个FAST_MUTEX来同步加1操作. 线程过程如下,没什么特别说明的,其中为了照顾偶的眼球眨动频率,特地做了1s的延时. DDKAPI VOID CountThreadMain(IN">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">[原创]W2k Driving 学习笔记(一)内核线程及同步</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>[大体流程]</strong></p>
<p>Win32与Kernel交互,从User层向内核发送2个请求:</p>
<p>0 IOCTL_Start_Thread : 从内核新建一个线程，最多建立MAX_THREAD_NUM个线程；</p>
<p>1 IOCTL_Stop_Thread : 关闭刚才建立的所有线程；</p>
<p>每个线程做同样的事，每次将变量Count增加1，使用一个FAST_MUTEX来同步加1操作。</p>
<p>线程过程如下，没什么特别说明的，其中为了照顾偶的眼球眨动频率，特地做了1s的延时。</p>
<p>DDKAPI VOID CountThreadMain(IN PVOID pContext)<br />
{<br />
	PDEVICE_EX pDevEx = (PDEVICE_EX)pContext;<br />
	LARGE_INTEGER dt = RtlConvertLongToLargeInteger(/<br />
			-10 * 1000 * 1000);<br />
	ULONG tid = (ULONG)PsGetCurrentThreadId();<br />
	PRINT("[%s]entry new thread[id:%d]",/<br />
		__func__,tid);</p>
<p>while(!pDevEx-&gt;bEXIT_THREADS)<br />
	{<br />
		ExAcquireFastMutex(&amp;pDevEx-&gt;FastMtx);<br />
		++pDevEx-&gt;Count;<br />
		ExReleaseFastMutex(&amp;pDevEx-&gt;FastMtx);<br />
		PRINT("[%s][tid:%d]Now Count is %d/n",/<br />
			__func__,tid,pDevEx-&gt;Count);<br />
		if(!NT_SUCCESS(KeDelayExecutionThread(KernelMode,/<br />
			false,&amp;dt)))<br />
		{<br />
			PRINT("[%s]err : Delay Failed!/n",__func__);<br />
			break;<br />
		}<br />
	}</p>
<p>PRINT("[%s]exit thread[id:%d]/n",/<br />
		__func__,tid);<br />
	(VOID)PsTerminateSystemThread(STATUS_SUCCESS);<br />
}</p>
<p> </p>
<p>在退时要注意，在未退出所有线程之前，绝不能Unload Driver，否则线程所在的内存</p>
<p>区将会被Unmap，系统将会发生缺页0x0E异常。我做了一个等待处理:</p>
<p>DDKAPI VOID WaitKillThreads(PDEVICE_OBJECT pDeviceObject)<br />
{<br />
	PDEVICE_EX pDevEx = (PDEVICE_EX)pDeviceObject-&gt;DeviceExtension;</p>
<p>PRINT("[%s]sizeof WAIT_BLOCK is %d/n",__func__,sizeof(KWAIT_BLOCK));<br />
	if(pDevEx-&gt;CURRENT_THREAD_NUM == 0)<br />
		return;</p>
<p>pDevEx-&gt;bEXIT_THREADS = TRUE;<br />
	PKWAIT_BLOCK pKB = (PKWAIT_BLOCK)ExAllocatePool(/<br />
		NonPagedPool,/<br />
		sizeof(KWAIT_BLOCK)*pDevEx-&gt;CURRENT_THREAD_NUM);</p>
<p>if(pKB == NULL)<br />
	{<br />
		PRINT("[%s]Alloc Mem Failed!/n",__func__);<br />
		return;<br />
	}</p>
<p>if(!NT_SUCCESS(KeWaitForMultipleObjects(/<br />
		pDevEx-&gt;CURRENT_THREAD_NUM,/<br />
		pDevEx-&gt;pThreadObjs,WaitAll,/<br />
		Executive,KernelMode,TRUE,/<br />
		NULL,pKB)))<br />
	{<br />
		PRINT("[%s]KeWaitForMultipleObjects Failed!/n",/<br />
			__func__);<br />
	}</p>
<p>ExFreePool((PVOID)pKB);<br />
}</p>
<p> </p>
<p>原先的WaitKillThreads老是导致系统蓝屏，调试发现只有当建立的线程数超过3个时</p>
<p>才会蓝屏，进一步分析，蓝屏的原因是WaitKillThreads将DrvDispatchControl的</p>
<p>第2个参数pIrp写成了垃圾数据。为什么只有当Thread数大于3时才这样呢？观察</p>
<p>WaitKillThreads中可能会擦写内核栈的只有KeWaitForMultipleObjects的回写操作</p>
<p>(pKB),查阅DDK Helps 之后发现，如果等待的对象&gt; THREAD_WAIT_OBJECTS则，</p>
<p>必须分配<strong> sizeof(</strong>KWAIT_BLOCK<strong>)</strong> * <em>Count </em>字节的非分页内存让其写入。一查</p>
<p>THREAD_WAIT_OBJECTS大小正好等于3，答案揭晓:</p>
<p>WaitKillThreads在最高优化中是内联编入派遣过程，这意味着它们共用一个函数栈桢，</p>
<p>KWAIT_BLOCK大小为24,则如果线程数大于3则正好溢出覆盖掉pIrp内容，My God！</p>
<p> </p>
<p>另外，在编译代码是发现找不到WaitAll或WaitAny的声明，我用的是MinGW(gcc)5.1.4</p>
<p>版本，在winddk.h中发现其将WAIT_TYPE定义成ULONG,将其改为:</p>
<p>typedef enum _WAIT_TYPE<br />
{<br />
  WaitAll,<br />
  WaitAny<br />
}WAIT_TYPE;</p>
<p> </p>
<p>后建立成功。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 02:45:57</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>[原创]W2k Driving 学习笔记(一)内核线程及同步的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjkmQp.html" rel="bookmark">&lbrack;原创&rsqb;W2k Driving 学习笔记&lpar;二&rpar;使用GCC创建 Windows NT 下的内核DLL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				         再温习&lt;&lt;Windows 2000 Driving&gt;&gt;分层驱动程序一章的时候,看到了关于紧耦合 驱动连接方式,这种方式不依赖于I/O管理器的串联,而是直接调用内核例程,这样可以大 大的提高驱动的执行效率.      为了实现这样一种功能,必须提供一种类似于在用户模式中DLL的机制,只不过该&quot;DLL&quot; 是加载到内核中的.其实Windows NT 内核本身早就利用了这样机制,比如Hal.dll.ntoskrnl.exe和某些类驱动程序等,他们分别为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQJOOp.html" rel="bookmark">API Demos 2&period;3 学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				API Demos 2.3 学习笔记 Doc和Pdf版本同步更新,请使用git工具进行同步.关于Git工具更多信息,请参考:http://progit.org/book/zh/ git clone https://code.google.com/p/apidemo/  或者 git clone git://github.com/snowdream/apidemo.git 由于笔者才疏识浅.时间匆忙,书中难免出现错误.缺点,欢迎大家批评指正.联系方式:yanghui1986527#gmail.co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LpdenNz.html" rel="bookmark">kernel学习：内核线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于内核对进程和线程不做区分,所以内核线程(kernel thread)又称为内核进程(kernel process).注意不能把普通进程中的线程理解为进程. 内核线程和普通进程的区别: 1.内核线程只运行在内核态,普通进程可以运行在内核态和用户态. 2.内核线程只能调用内核函数,普通进程可以通过系统调用调用内核函数. 3.内核线程只能运行在大于PAGE_OFFSET的地址空间,而普通进程可以4G的地址空间(除了访问用户空间的3G,通过系统调用可以访问内核空间的1G空间). 由于内核线程不受用户			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo7kZVb.html" rel="bookmark">《Java并发编程实战》学习笔记 线程安全、共享对象和组合对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一章 介绍 线程的优势: 充分利用多处理器 简化模型 简化异步事件的处理 提供用户界面的响应(时间) 线程的风险: 安全的风险(不好的事情会发生),提高错误出现的几率 活性的风险(好的事情不会发生),如某些代码不会执行,出现死锁.活锁以及饥饿 性能的风险,不好的多线程编程可能会危害性能 第二章 线程安全 编写线程安全的代码,实质是管理对状态的访问,尤其是那些共享.可变的状态.对象的状态包括任何能影响它外部可见行为的数据. 当有过个线程能访问状态变量时,而且他们当中能对变量进行修改,则需要对他们			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnwKA0z.html" rel="bookmark">Qt学习笔记  线程&lpar;一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Qt中的线程是与平台无关的 QThread 提供了创建一个新线程的方法 新建一个线程,继承QThread并重写它的run()当调用 start()函数时会调用重载的run()函数 例: #ifndef MYTHREAD_H #define MYTHREAD_H #include &lt;QThread&gt; class MyThread : public QThread { Q_OBJECT public: bool stop ; explicit MyThread(QObject *parent =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6dmoM.html" rel="bookmark">kvm虚拟化学习笔记&lpar;二十一&rpar;之KVM性能优化学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://koumm.blog.51cto.com/703525/1606422 本学习笔记系列都是采用CentOS6.x操作系统,KVM虚拟机的管理也是采用virsh方式,网上的很多的文章都基于ubuntu高版本内核下,KVM的一些新的特性支持更好,本文只是记录了CentOS6.x系列操作系统下KVM优化的点,有很多都是默认支持开启了的,除了采用virtio方式的磁盘IO,与网络IO接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlO2Lqb.html" rel="bookmark">JVM学习笔记（四）------内存调优【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/cutesource/article/details/5907418 版权声明:本文为博主原创文章,未经博主允许不得转载. 首先需要注意的是在对JVM内存调优的时候不能只看操作系统级别Java进程所占用的内存,这个数值不能准确的反应堆内存的真实占用情况,因为GC过后这个值是不会变化的,因此内存调优的时候要更多地使用JDK提供的内存查看工具,比如JConsole和Java VisualVM. 对JVM内存的系统级的调优主要的目的是减少GC的频率和Fu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zG0G3b.html" rel="bookmark">java对象序列化学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java对象|笔记 目前网络上关于对象序列化的文章不少,但是我发现详细叙述用法和原理的文章太少.本人把自己经过经验总结和实际运用中的体会写成的学习笔记贡献给大家.希望能为整个java社区的繁荣做一点事情.    序列化的过程就是对象写入字节流和从字节流中读取对象.将对象状态转换成字节流之后,可以用java.io包中的各种字节流类将其保存到文件中,管道到另一线程中或通过网络连接将对象数据发送到另一主机.对象序列化功能非常简单.强大,在RMI.Socket.JMS.EJB都有应用.对象序列化问题在网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/wzVYBmp.html" rel="bookmark">MySQL数据库学习笔记（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql|笔记|数据|数据库         我一直从事Informix和Oracle数据库开发,有一天发现网络上有一种小巧别致的数据库,被广泛使用,从MySQL的网站http://www.mysql.com/我下载了它的数据库软件,使用过后觉得真的挺好,这是我的一点学习笔记希望对各位初学者有点帮助. 1.       MySQL数据库介绍 MySQL 是瑞典的MySQL AB公司开发的一个可用于各种流行操作系统平台的关系数据库系统,它具有客户机/服务器体系结构的分布式数据库管理系统.MySQ			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8gnxM.html" rel="bookmark" class="title">web标准实现高效开发系列之二</a>
					<div>
						web|web标准 web标准让大家学会了手写代码,显然这样的效率不够高.关于高效开发早已提到了web标准推广的日程上来了,可是现在的成效还不是很让人满意,我个人观点,开发的时候从整体到局部,提高开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaKy2p.html" rel="bookmark" class="title">Apache服务器二级域名的完美实现</a>
					<div>
						首先,你的拥有一个有泛域名解析的顶级域名,例如: domain.com 其次,在 httpd.conf 中打开 mod_rewrite 之后,在 httpd.conf 的最后,添加以下内容: 以下为引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEBy3M.html" rel="bookmark" class="title">钟智鑫：百度账号被惩罚后的连锁反应</a>
					<div>
						今天看了一下统计工具,发现我的垃圾站(专门用来放联盟弹窗广告的,没有什么用户体验)流量少了很多,这就相当于人民币少了啊,这不行,这就要找一下原因了. 看了一下来源统计,发现百度知道,百度空间,百度贴吧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRvRNz.html" rel="bookmark" class="title">WPF Bug清单之&lpar;8&rpar;&mdash;&mdash;RowDefinition中MaxHeight在一定条件下失效</a>
					<div>
						再下一城. BUG描述:当RowDefinition的Height属性被设置为Auto时,MaxHeight将不会对这个Row的Height起到限制作用. Bug发现过程:想做一个像Visual St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPdDwz.html" rel="bookmark" class="title">完全卸载oracle&vert;oracle卸载&vert;彻底卸载oracle</a>
					<div>
						  因为之安装Oracle 10G的时候出了点问题,后来叫舍友重新发了一份Oralce 10g 客户端安装包过来装上去了. 当初使用PL/SQL是可以的,后来在因为工作需要,在一次导入同事发来的一份O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wqwrp.html" rel="bookmark" class="title">excel如何把日期yy-mm-dd变成yy&sol;mm&sol;dd&sol;格式</a>
					<div>
						  excel如何把日期yy-mm-dd变成yy/mm/dd/格式         步骤 1.打开excel表,这个表是我做演示案例用的,仅供参考.因为智修改日期,所以我只新建了日期一列. 2.选中需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oZqDb.html" rel="bookmark" class="title">Word2007：SmartArt图形样式的选择</a>
					<div>
						  在前面,对Word2007中的SmartArt图形了解了位置.大小.文字环绕方式以及颜色的设置,而SmartArt图形样式,我们现在也来做个了解.在Word2007中,提供了多种样式,可以使Sma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42mKrM.html" rel="bookmark" class="title">不用任何工具实现两台笔记本的资源共享</a>
					<div>
						正常情况如果是没有网络,我们要实现两台笔记本的资源共享,基本上要通过网线连接两台笔记本然后才能互相传递文件.而如果你的两台笔记本中其中有一台是win7系统,那么你就可以轻松把win7系统的笔记本设成无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZB0Vz.html" rel="bookmark" class="title">最全的C盘可删除文件清单</a>
					<div>
						  一.关闭Win7系统休眠功能 &quot;以管理员身份运行,所有程序→附件→命令提示符&quot;,右击选择&quot;以管理员身份运行&quot;,进入命令提示符后,手工输入&quot;powe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOl37Rb.html" rel="bookmark" class="title">JS保留小数点&lpar;四舍五入、四舍六入&rpar;实现思路及实例&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.01 Transitional//EN&quot;&gt; &lt;html& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA7GkM.html" rel="bookmark" class="title">python文件语句解析-请高手帮我解释下这些语句的意思，跪谢！</a>
					<div>
						问题描述 请高手帮我解释下这些语句的意思,跪谢! import osimport ref_cg=open('dm_cg.txt''w')f_sb=open('dm_sb.txt''w')dir_lis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My32NJz.html" rel="bookmark" class="title">请问adobe flash professional 中插入帧，插入关键帧，插入空白关键帧的差别？</a>
					<div>
						问题描述 请问adobe flash professional 中插入帧,插入关键帧,插入空白关键帧的差别? 感觉插入帧时,会在原有帧的基础上,改变原来帧的内容,而插入关键帧,同样是在原有帧的基础上, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7L8jz.html" rel="bookmark" class="title">jQuery如何实现在ul下添加一张图片自动给改图片添加一个li标签啊</a>
					<div>
						问题描述 jQuery如何实现在ul下添加一张图片自动给改图片添加一个li标签啊 我要实现的效果就是,在ul下添加N张图片,可以从后台任意添加,但是每添加一张图片,都会自动给该图片添加一个li标签,自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3q58z.html" rel="bookmark" class="title">java pos机 USB无驱动打印</a>
					<div>
						问题描述 java pos机 USB无驱动打印 pos机器上有些特殊指令,不能使用驱动,电脑lpt1口坏了,只有USB接口好的,求USB打印代码,网上搜索了些 但这个再我的电脑使用会出现异常 publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAk0RM.html" rel="bookmark" class="title">一个新手一个月做到日赚百元的启示</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 昨晚周末,侄子过来找我.他一脸的兴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQqVYp.html" rel="bookmark" class="title">《Cocos2D权威指南》&mdash;&mdash;导读</a>
					<div>
						前言 为什么要写这本书 2011年10月5日,秋风萧瑟,阴雨绵绵,在这颗蔚蓝色的美丽星球上,一代传奇伟人乔布斯在亲友的陪伴下安然离去,宛若流星划过天际,空留那辆银色的奔驰SL55AMG在落叶纷飞中孤独 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKLPKz.html" rel="bookmark" class="title">界面-openstack 云主机起不来。虚拟接口创建错误</a>
					<div>
						问题描述 openstack 云主机起不来.虚拟接口创建错误 这问题缠了我2天了,重做了好多次,刚开始以为是网络那里出错了. 可是再怎么细心还是出错,已经心灰意冷了. 我服务器当controller节 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL31Wp.html" rel="bookmark" class="title">Drizzle 2011&period;08&period;25发布 精简版的MySQL分支</a>
					<div>
						Drizzle 2011.08.25该版本现在允许0,等于NULL,但空值均为0.这个版本将采用http://www.aliyun.com/zixun/aggregation/9485.html&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7qVRz.html" rel="bookmark" class="title">你了解了多少Google&lpar;1&rpar;</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 Google良好的搜索和易用性已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5K0dp.html" rel="bookmark" class="title">移动互联网时代&OpenCurlyDoubleQuote;宁做榴莲，不做香蕉&rdquo;</a>
					<div>
						本文讲的是移动互联网时代&quot;宁做榴莲,不做香蕉&quot;,手机端庞大的用户群体快速崛起,&quot;开放&quot;.&quot;连接&quot;.&quot;共享&quot;构成移动互联网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeDYZM.html" rel="bookmark" class="title">小白，docker中运行nodejs网页保报错，Object function Object&lpar;&rpar; &lbrace; &lbrack;native code&rsqb; &rcub; has no method</a>
					<div>
						问题描述 TypeError:ObjectfunctionObject(){[nativecode]}hasnomethod'assign'atObject.build(/p3/node_module ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqXKJp.html" rel="bookmark" class="title">大数据时代下的银行业：围绕客户体验创新求变</a>
					<div>
						大数据时代下的银行业:围绕客户体验创新求变 &quot;中国金融服务业正在发生翻天覆地的变化,除了持续的金融系统改革外,中国的商业银行面临着更具挑战的客户预期以及诸多新机构的竞争.为了保持竞争优势,金 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1N3Ajp.html" rel="bookmark" class="title">构建哲学社会科学现代传播体系（信息快递）</a>
					<div>
						中国http://www.aliyun.com/zixun/aggregation/39459.html&quot;&gt;社会科学院主办.中国社会科学网承办的&quot;社会科学网络传播国际论坛&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk1OLp.html" rel="bookmark" class="title">求助关于JAVA，模拟AMF提交，以及解析AMF的问题</a>
					<div>
						问题描述 各位大大.最近迷上了一款网页游戏.flash做的,于是乎想开发一个辅助工具,但是最终在做的时候,检测到服务器和客户端用的AMF传输,传输的都是对象,自己对这方面并不了解,所以想请大大给一点思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWl6Pz.html" rel="bookmark" class="title">奇怪的越界</a>
					<div>
						问题描述 DimiAsIntegerDimjAsIntegerDimnAsIntegerDimmAsStringDimkecheng(1000)AsString'ReDimPreservekechen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmem3z.html" rel="bookmark" class="title">美国-JAVA课程编程作业疑问</a>
					<div>
						问题描述 JAVA课程编程作业疑问 老师要求的用户界面显示结果如下: This program computes the total cost of a purchase. Enter the pri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2aWOz.html" rel="bookmark" class="title">戴姆勒在东京车展拿出电动卡车，11吨载重&plus;350公里续航</a>
					<div>
						戴姆勒在东京车展拿出电动卡车,最大载重11吨,续航350公里左右. 是的,350公里续航依然不足以用来做真正的长途运输,但是在距离较近的城市间运货已经足够了,而且在中程运输中提供了更多的灵活性. 戴姆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1D7e5b.html" rel="bookmark" class="title">框架的好出&comma;如ssh&quest;</a>
					<div>
						问题描述 谢谢!框架的好出,如ssh?但我想要的是具体的步骤,有没有快快速的方法? 解决方案 解决方案二:好处就是提高开发效率,降低耦合度...我是菜鸟,说错了别骂我...解决方案三:楼上的说的不错也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0vqdM.html" rel="bookmark" class="title">关于qt读取xml文件并作为excel文件表头</a>
					<div>
						问题描述 关于qt读取xml文件并作为excel文件表头 新使用Qt,求大神指点:如何使用Qt读取xml文件,然后将其节点属性作为excel文件的表头输出呢? 解决方案 http://blog.csd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnO42Oz.html" rel="bookmark" class="title">2017年第二季度全球科技公司IPO报告出炉，两年来科技IPO最好的一季</a>
					<div>
						近期,普华永道发布了2017年第二季度全球科技公司的IPO报告,该报告的数据来源于S&amp;P Capital IQ(标普智汇). 雷锋网(公众号:雷锋网)根据报告总结出了以下四个要点: 这个季度是 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
